version: "3.9"
services:
  grafana:
    image: grafana/grafana:latest
    user: "$UID:$GID"
    restart: unless-stopped
    environment:
      GF_SECURITY_ADMIN_PASSWORD: {{ cloudstack.plugins.grafana.config.password }}
      GF_USERS_ALLOW_SIGN_UP: "false"
      GF_INSTALL_PLUGINS: grafana-piechart-panel
      GF_DEFAULT_INSTANCE_NAME: {{ cloudstack.plugins.grafana.config.sitename }}
      GF_SERVER_ROOT_URL: https://{{ cloudstack.plugins.grafana.config.sitename }}
      GF_AUTH_GENERIC_OAUTH_ENABLED: "true"
      GF_AUTH_GENERIC_OAUTH_NAME: "Authentik"
      GF_AUTH_GENERIC_OAUTH_CLIENT_ID: "{{ cloudstack.plugins.grafana.config.authentik.client.id }}"
      GF_AUTH_GENERIC_OAUTH_CLIENT_SECRET: "{{ cloudstack.plugins.grafana.config.authentik.client.secret }}"
      GF_AUTH_GENERIC_OAUTH_SCOPES: "openid profile email"
      GF_AUTH_GENERIC_OAUTH_AUTH_URL: "https://{{ cloudstack.plugins.authentik.config.sitename }}/application/o/authorize/"
      GF_AUTH_GENERIC_OAUTH_TOKEN_URL: "https://{{ cloudstack.plugins.authentik.config.sitename }}/application/o/token/"
      GF_AUTH_GENERIC_OAUTH_API_URL: "https://{{ cloudstack.plugins.authentik.config.sitename }}/application/o/userinfo/"
      GF_AUTH_SIGNOUT_REDIRECT_URL: "https://{{ cloudstack.plugins.authentik.config.sitename }}/application/o/{{ cloudstack.plugins.grafana.config.authentik.slug }}/end-session/"
      # Optionally enable auto-login (bypasses Grafana login screen)
      GF_AUTH_OAUTH_AUTO_LOGIN: "false"
      # Optionally map user groups to Grafana roles
      GF_AUTH_GENERIC_OAUTH_ROLE_ATTRIBUTE_PATH: "contains(groups[*], 'Grafana Admins') && 'Admin' || contains(groups[*], 'Grafana Admins') && 'Editor' || 'Viewer'"
    networks:
      - loki
      - grafana
      - traefik
      - prometheus
      - elasticsearch
    volumes:
      - /opt/cloudstack/grafana/data:/var/lib/grafana
      - /opt/cloudstack/grafana/provisioning/:/etc/grafana/provisioning/
    labels:
      - 'traefik.enable=true'
      - 'traefik.docker.network=traefik'
      - 'traefik.http.routers.grafana.rule=Host(`{{ cloudstack.plugins.grafana.config.sitename }}`)'
      - 'traefik.http.routers.grafana.entrypoints=web,websecure'
      - 'traefik.http.routers.grafana.service=grafana'
      - 'traefik.http.services.grafana.loadbalancer.server.port=3000'
      - 'traefik.http.services.grafana.loadbalancer.passhostheader=true'
      - 'traefik.http.routers.grafana.middlewares=allow-dashboard@docker,redirect-to-https@docker'
      - "docker-volume-backup.stop-during-backup=true"
  #https://github.com/jareware/docker-volume-backup#s3-bucket-setup
  backup:
    image: jareware/docker-volume-backup:2.6.0
    environment:
      AWS_S3_BUCKET_NAME: {{ cloudstack.plugins.backup.config.bucket }}/{{ plugin }}      # S3 bucket which you own, and already exists
      AWS_ACCESS_KEY_ID: {{ cloudstack.plugins.backup.config.user | default(cloudstack.plugins.minio.config.user) }}
      AWS_SECRET_ACCESS_KEY: {{ cloudstack.plugins.backup.config.password | default(cloudstack.plugins.minio.config.password) }}
      AWS_EXTRA_ARGS: "--endpoint-url {{ cloudstack.plugins.backup.config.endpoint }}"
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock:ro # Allow use of the "stop-during-backup" feature
      - /opt/cloudstack/grafana/data:/backup/grafana-data:ro
    networks:
      - s3

networks:
  grafana:
    name: grafana
  traefik:
    external: true
  loki:
    external: true
  prometheus:
    external: true
  elasticsearch:
    external: true
  s3:
    external: true